Index: /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icevar.F90
===================================================================
--- /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icevar.F90	(revision 8485)
+++ /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icevar.F90	(revision 8486)
@@ -512,12 +482,11 @@
       !!
       !! ** Purpose :   Remove too small sea ice areas and correct fluxes
-      !!
-      !! history : LIM3.5 - 01-2014 (C. Rousset) original code
       !!-------------------------------------------------------------------
       INTEGER  ::   ji, jj, jl, jk   ! dummy loop indices
       REAL(wp) ::   zsal, zvi, zvs, zei, zes, zvp
       !!-------------------------------------------------------------------
-      DO jl = 1, jpl
-
+      !
+      DO jl = 1, jpl       !==  loop over the categories  ==!
+         !
          !-----------------------------------------------------------------
          ! Zap ice energy and use ocean heat to melt ice
@@ -526,4 +495,5 @@
             DO jj = 1 , jpj
                DO ji = 1 , jpi
+!!gm I think we can do better/faster  :  to be discussed
                   rswitch          = MAX( 0._wp , SIGN( 1._wp, a_i(ji,jj,jl) - epsi10 ) )
                   rswitch          = MAX( 0._wp , SIGN( 1._wp, v_i(ji,jj,jl) - epsi10 ) ) * rswitch
@@ -588,10 +558,12 @@
 
       ! to be sure that at_i is the sum of a_i(jl)
-      at_i (:,:) = 0._wp
-      DO jl = 1, jpl
+      at_i (:,:) = a_i(:,:,1)
+	  vt_i (:,:) = v_i(:,:,1)
+      DO jl = 2, jpl
          at_i(:,:) = at_i(:,:) + a_i(:,:,jl)
+	     vt_i(:,:) = vt_i(:,:) + v_i(:,:,jl)
       END DO
 
-      ! open water = 1 if at_i=0
+      ! open water = 1 if at_i=0 (no re-calculation of ato_i here)
       DO jj = 1, jpj
          DO ji = 1, jpi
@@ -600,7 +572,7 @@
          END DO
       END DO
-
       !
    END SUBROUTINE ice_var_zapsmall
+
 
    SUBROUTINE ice_var_itd( zhti, zhts, zai, zht_i, zht_s, za_i )
@@ -633,10 +605,5 @@
       !!
       !!  (Example of application: BDY forcings when input are cell averaged)  
-      !!
       !!-------------------------------------------------------------------
-      !! History : LIM3.5 - 2012    (M. Vancoppenolle)  Original code
-      !!                    2014    (C. Rousset)        Rewriting
-      !!-------------------------------------------------------------------
-      !! Local variables
       INTEGER  :: ji, jk, jl             ! dummy loop indices
       INTEGER  :: ijpij, i_fill, jl0  
@@ -645,9 +612,10 @@
       REAL(wp), DIMENSION(:,:), INTENT(inout) ::   zht_i, zht_s, za_i ! output ice/snow variables
       INTEGER , DIMENSION(4)                  ::   itest
- 
+      !!-------------------------------------------------------------------
+
       !--------------------------------------------------------------------
       ! initialisation of variables
       !--------------------------------------------------------------------
-      ijpij = SIZE(zhti,1)
+      ijpij = SIZE( zhti , 1 )
       zht_i(1:ijpij,1:jpl) = 0._wp
       zht_s(1:ijpij,1:jpl) = 0._wp
@@ -766,9 +734,8 @@
                zht_s(ji,jl) = MAX( 0._wp, zht_s(ji,jl) - zdh * rhoic * r1_rhosn )
             ENDIF
-         ENDDO
-      ENDDO
+         END DO
+      END DO
       !
     END SUBROUTINE ice_var_itd
-
 
 #else
@@ -776,7 +743,4 @@
    !!   Default option         Dummy module          NO  LIM3 sea-ice model
    !!----------------------------------------------------------------------
-CONTAINS
-   SUBROUTINE ice_var_itd
-   END SUBROUTINE ice_var_itd
 #endif
 
Index: /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icewri.F90
===================================================================
--- /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icewri.F90	(revision 8485)
+++ /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icewri.F90	(revision 8486)
@@ -8,31 +8,31 @@
    !!   'key_lim3'                                      LIM3 sea-ice model
    !!----------------------------------------------------------------------
-   !!   ice_wri      : write of the diagnostics variables in ouput file 
+   !!   ice_wri       : write of the diagnostics variables in ouput file 
    !!   ice_wri_state : write for initial state or/and abandon
    !!----------------------------------------------------------------------
-   USE ioipsl
-   USE dianam          ! build name of file (routine)
-   USE phycst
-   USE dom_oce
-   USE sbc_oce
-   USE sbc_ice         ! Surface boundary condition: ice fields
-   USE ice
-   USE icevar
+   USE dianam         ! build name of file (routine)
+   USE phycst         ! physical constant
+   USE dom_oce        ! domain: ocean
+   USE sbc_oce        ! surf. boundary cond.: ocean
+   USE sbc_ice        ! Surface boundary condition: ice fields
+   USE ice            ! sea-ice: variables
+   USE icevar         ! sea-ice: operations
    !
-   USE in_out_manager
-   USE lbclnk
-   USE lib_mpp         ! MPP library
-   USE iom
-   USE timing          ! Timing
-   USE lib_fortran     ! Fortran utilities
+   USE ioipsl         !
+   USE in_out_manager !
+   USE lbclnk         !
+   USE lib_mpp        ! MPP library
+   USE iom            !
+   USE timing         ! Timing
+   USE lib_fortran    ! Fortran utilities
 
    IMPLICIT NONE
    PRIVATE
 
-   PUBLIC ice_wri        ! routine called by lim_step.F90
+   PUBLIC ice_wri        ! called by ice_stp
    PUBLIC ice_wri_state  ! called by dia_wri_state 
 
    !!----------------------------------------------------------------------
-   !! NEMO/LIM3 4.0 , UCL - NEMO Consortium (2011)
+   !! NEMO/ICE 4.0 , NEMO Consortium (2017)
    !! $Id: icewri.F90 8409 2017-08-07 15:29:21Z clem $
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -55,21 +55,16 @@
       REAL(wp) ::  z2da, z2db, ztmp, zrho1, zrho2, zmiss_val
       REAL(wp) ::  zs12, zshear
+      REAL(wp), DIMENSION(jpi,jpj)     ::  z2d, zswi, zmiss !  2D workspace
+      REAL(wp), DIMENSION(jpi,jpj)     ::  zfb              ! ice freeboard
+      REAL(wp), DIMENSION(jpi,jpj)     ::  zamask, zamask15 ! 15% concentration mask
+      REAL(wp), DIMENSION(jpi,jpj)     ::  zsig1, zsig2, zsig3
       REAL(wp), DIMENSION(jpi,jpj,jpl) ::  zswi2, zmiss2
-      REAL(wp), DIMENSION(jpi,jpj)   ::  z2d, zswi, zmiss !  2D workspace
-      REAL(wp), DIMENSION(jpi,jpj)   ::  zfb              ! ice freeboard
-      REAL(wp), DIMENSION(jpi,jpj)   ::  zamask, zamask15 ! 15% concentration mask
-      REAL(wp), DIMENSION(jpi,jpj)   ::  zsig1, zsig2, zsig3
-
+      !
       ! Global ice diagnostics (SIMIP)
-      REAL(wp) ::  zdiag_area_nh, &   ! area, extent, volume
-         &         zdiag_extt_nh, &
-         &         zdiag_area_sh, & 
-         &         zdiag_extt_sh, & 
-         &         zdiag_volu_nh, & 
-         &         zdiag_volu_sh 
-
+      REAL(wp) ::  zdiag_area_nh, zdiag_extt_nh, zdiag_volu_nh   ! area, extent, volume
+      REAL(wp) ::  zdiag_area_sh, zdiag_extt_sh, zdiag_volu_sh 
       !!-------------------------------------------------------------------
 
-      IF( nn_timing == 1 )  CALL timing_start('icewri')
+      IF( nn_timing == 1 )   CALL timing_start('icewri')
 
       !----------------------------------------
@@ -77,6 +72,5 @@
       !----------------------------------------
 
-      ! brine volume
-      CALL ice_var_bv 
+      CALL ice_var_bv      ! brine volume
 
       ! tresholds for outputs
@@ -96,7 +90,7 @@
       END DO
 
-      zmiss_val     = 1.0e20
-      zmiss(:,:)    = zmiss_val * ( 1. - zswi(:,:) )
-      zmiss2(:,:,:) = zmiss_val * ( 1. - zswi2(:,:,:) )
+      zmiss_val     = 1.e20_wp
+      zmiss (:,:)   = zmiss_val * ( 1._wp - zswi (:,:) )
+      zmiss2(:,:,:) = zmiss_val * ( 1._wp - zswi2(:,:,:) )
 
       !----------------------------------------
@@ -112,32 +106,33 @@
       IF( iom_use('qt_ice' ) )   CALL iom_put( "qt_ice"  , SUM( ( qns_ice(:,:,:) + qsr_ice(:,:,:) )   &
          &                                                      * a_i_b(:,:,:), dim=3 ) + qemp_ice(:,:) )
+!!gm I don't understand the variable below.... why not multiplied by a_i_b or (1-a_i_b) ??? 
       IF( iom_use('qemp_oce') )  CALL iom_put( "qemp_oce" , qemp_oce(:,:) )  
       IF( iom_use('qemp_ice') )  CALL iom_put( "qemp_ice" , qemp_ice(:,:) )  
-      IF( iom_use('emp_oce' ) )  CALL iom_put( "emp_oce"  , emp_oce(:,:) )   ! emp over ocean (taking into account the snow blown away from the ice)
-      IF( iom_use('emp_ice' ) )  CALL iom_put( "emp_ice"  , emp_ice(:,:) )   ! emp over ice   (taking into account the snow blown away from the ice)
+      IF( iom_use('emp_oce' ) )  CALL iom_put( "emp_oce"  , emp_oce (:,:) )   ! emp over ocean (taking into account the snow blown away from the ice)
+      IF( iom_use('emp_ice' ) )  CALL iom_put( "emp_ice"  , emp_ice (:,:) )   ! emp over ice   (taking into account the snow blown away from the ice)
 
       ! velocity
-      IF ( iom_use('uice_ipa') ) CALL iom_put( "uice_ipa"     , u_ice      )       ! ice velocity u component
-      IF ( iom_use('vice_ipa') ) CALL iom_put( "vice_ipa"     , v_ice      )       ! ice velocity v component
-
-      IF ( ( iom_use( "icevel" ) ) .OR. ( iom_use( "icevel_mv" ) ) ) THEN 
+      IF( iom_use('uice_ipa') )  CALL iom_put( "uice_ipa" , u_ice         )   ! ice velocity u component
+      IF( iom_use('vice_ipa') )  CALL iom_put( "vice_ipa" , v_ice         )   ! ice velocity v component
+
+      IF( iom_use('icevel') .OR. iom_use('icevel_mv') ) THEN 
          DO jj = 2 , jpjm1
             DO ji = 2 , jpim1
-               z2da  = ( u_ice(ji,jj) * umask(ji,jj,1) + u_ice(ji-1,jj) * umask(ji-1,jj,1) ) * 0.5_wp
-               z2db  = ( v_ice(ji,jj) * vmask(ji,jj,1) + v_ice(ji,jj-1) * vmask(ji,jj-1,1) ) * 0.5_wp
-               z2d(ji,jj) = SQRT( z2da * z2da + z2db * z2db )
+               z2da  = ( u_ice(ji,jj) + u_ice(ji-1,jj) )
+               z2db  = ( v_ice(ji,jj) + v_ice(ji,jj-1) )
+               z2d(ji,jj) = O.5_wp * SQRT( z2da * z2da + z2db * z2db )
            END DO
          END DO
          CALL lbc_lnk( z2d, 'T', 1. )
-         IF ( iom_use( "icevel" )  )   CALL iom_put( "icevel"       , z2d        )                                            ! ice velocity module
-         IF ( iom_use( "icevel_mv" ) ) CALL iom_put( "icevel_mv"    , z2d(:,:) * zswi(:,:) + zmiss(:,:) )                     ! ice velocity module (missing value)
-      ENDIF
-
-      IF ( iom_use( "tau_icebfr" ) )    CALL iom_put( "tau_icebfr"  , tau_icebfr             )  ! ice friction with ocean bottom (landfast ice)  
-      !
-      IF ( iom_use( "miceage" ) )       CALL iom_put( "miceage"     , om_i * zswi * zamask15 )  ! mean ice age
-      IF ( iom_use( "micet" ) )         CALL iom_put( "micet"       , ( tm_i  - rt0 ) * zswi )  ! ice mean    temperature
-      IF ( iom_use( "icest" ) )         CALL iom_put( "icest"       , ( tm_su - rt0 ) * zswi )  ! ice surface temperature
-      IF ( iom_use( "icecolf" ) )       CALL iom_put( "icecolf"     , hicol                  )  ! frazil ice collection thickness
+         IF( iom_use('icevel'   ) )   CALL iom_put( "icevel"       , z2d        )                          ! ice velocity module
+         IF( iom_use('icevel_mv') )   CALL iom_put( "icevel_mv"    , z2d(:,:) * zswi(:,:) + zmiss(:,:) )   ! ice velocity module (missing value)
+      ENDIF
+
+      IF( iom_use('tau_icebfr') )     CALL iom_put( "tau_icebfr"  , tau_icebfr             )  ! ice friction with ocean bottom (landfast ice)  
+      !
+      IF( iom_use('miceage')  )       CALL iom_put( "miceage"     , om_i * zswi * zamask15 )  ! mean ice age
+      IF( iom_use('micet')    )       CALL iom_put( "micet"       , ( tm_i  - rt0 ) * zswi )  ! ice mean    temperature
+      IF( iom_use('icest')    )       CALL iom_put( "icest"       , ( tm_su - rt0 ) * zswi )  ! ice surface temperature
+      IF( iom_use('icecolf')  )       CALL iom_put( "icecolf"     , hicol                  )  ! frazil ice collection thickness
       !
       CALL iom_put( "isst"        , sst_m               )        ! sea surface temperature
@@ -149,5 +144,5 @@
       CALL iom_put( "isnowhc"     , et_s  * zswi        )        ! snow total heat content
       CALL iom_put( "ibrinv"      , bvm_i * zswi * 100. )        ! brine volume
-      CALL iom_put( "snowpre"     , sprecip * 86400.    )        ! snow precipitation 
+      CALL iom_put( "snowpre"     , sprecip * 86400.    )        ! snow precipitation [m/day]
       CALL iom_put( "micesalt"    , smt_i   * zswi      )        ! mean ice salinity
       CALL iom_put( "snowvol"     , vt_s    * zswi      )        ! snow volume
@@ -224,6 +219,7 @@
       CALL iom_put ('hfxspr'     , hfx_spr(:,:)         )   ! Heat content of snow precip 
 
+!!gm ====>>>>>  THIS should be moved in icerhg_evp    (generalize this everywhere it is possible and logic...)
       ! specific outputs for EVP rheology
-      IF( iom_use( "isig1" ) .OR. iom_use( "isig2" ) .OR. iom_use( "isig3" ) ) THEN
+      IF( iom_use('isig1') .OR. iom_use('isig2') .OR. iom_use('isig3') ) THEN
          zsig1(:,:) = 0._wp; zsig2(:,:) = 0._wp; zsig3(:,:) = 0._wp;
          DO jj = 2, jpjm1
@@ -251,5 +247,7 @@
          CALL iom_put( "isig3" , zsig3 )
       ENDIF
-
+!!gm  <<<<<<======= end
+
+!!gm ====>>>>>  THIS should be moved where at_ip, vt_ip are computed fro the last time in the time-step  (limmpd)
       ! MV MP 2016
       IF ( ln_pnd ) THEN
@@ -258,27 +256,24 @@
       ENDIF
       ! END MV MP 2016
+!!gm  <<<<<<======= end
 
       !----------------------------------
       ! Output category-dependent fields
       !----------------------------------
-      IF ( iom_use( "iceconc_cat"  ) )  CALL iom_put( "iceconc_cat"      , a_i   * zswi2   )        ! area for categories
-      IF ( iom_use( "icethic_cat"  ) )  CALL iom_put( "icethic_cat"      , ht_i  * zswi2   )        ! thickness for categories
-      IF ( iom_use( "snowthic_cat" ) )  CALL iom_put( "snowthic_cat"     , ht_s  * zswi2   )        ! snow depth for categories
-      IF ( iom_use( "salinity_cat" ) )  CALL iom_put( "salinity_cat"     , sm_i  * zswi2   )        ! salinity for categories
-      ! ice temperature
-      IF ( iom_use( "icetemp_cat"  ) )  CALL iom_put( "icetemp_cat", ( SUM( t_i(:,:,:,:), dim=3 ) * r1_nlay_i - rt0 ) * zswi2 )
-      ! snow temperature
-      IF ( iom_use( "snwtemp_cat"  ) )  CALL iom_put( "snwtemp_cat", ( SUM( t_s(:,:,:,:), dim=3 ) * r1_nlay_s - rt0 ) * zswi2 )
-      ! ice age
-      IF ( iom_use( "iceage_cat"   ) )  CALL iom_put( "iceage_cat" , o_i * zswi2 ) 
-      ! brine volume
-      IF ( iom_use( "brinevol_cat" ) )  CALL iom_put( "brinevol_cat", bv_i * 100. * zswi2 )
+      IF ( iom_use('iceconc_cat' ) )  CALL iom_put( "iceconc_cat"      , a_i   * zswi2   )        ! area for categories
+      IF ( iom_use('icethic_cat' ) )  CALL iom_put( "icethic_cat"      , ht_i  * zswi2   )        ! thickness for categories
+      IF ( iom_use('snowthic_cat') )  CALL iom_put( "snowthic_cat"     , ht_s  * zswi2   )        ! snow depth for categories
+      IF ( iom_use('salinity_cat') )  CALL iom_put( "salinity_cat"     , sm_i  * zswi2   )        ! salinity for categories
+      IF ( iom_use('icetemp_cat' ) )  CALL iom_put( "icetemp_cat", ( SUM( t_i(:,:,:,:), dim=3 ) * r1_nlay_i - rt0 ) * zswi2 )    ! ice temperature
+      IF ( iom_use('snwtemp_cat' ) )  CALL iom_put( "snwtemp_cat", ( SUM( t_s(:,:,:,:), dim=3 ) * r1_nlay_s - rt0 ) * zswi2 )    ! snow temperature
+      IF ( iom_use('iceage_cat'  ) )  CALL iom_put( "iceage_cat" , o_i * zswi2 )                   ! ice age
+      IF ( iom_use('brinevol_cat') )  CALL iom_put( "brinevol_cat", bv_i * 100. * zswi2 )          ! brine volume
 
       ! MV MP 2016
       IF ( ln_pnd ) THEN
-         IF ( iom_use( "iceamp_cat"  ) )  CALL iom_put( "iceamp_cat"     , a_ip       * zswi2   )       ! melt pond frac for categories
-         IF ( iom_use( "icevmp_cat"  ) )  CALL iom_put( "icevmp_cat"     , v_ip       * zswi2   )       ! melt pond frac for categories
-         IF ( iom_use( "icehmp_cat"  ) )  CALL iom_put( "icehmp_cat"     , h_ip       * zswi2   )       ! melt pond frac for categories
-         IF ( iom_use( "iceafp_cat"  ) )  CALL iom_put( "iceafp_cat"     , a_ip_frac  * zswi2   )       ! melt pond frac for categories
+         IF ( iom_use('iceamp_cat') )  CALL iom_put( "iceamp_cat"     , a_ip       * zswi2   )       ! melt pond frac for categories
+         IF ( iom_use('icevmp_cat') )  CALL iom_put( "icevmp_cat"     , v_ip       * zswi2   )       ! melt pond frac for categories
+         IF ( iom_use('icehmp_cat') )  CALL iom_put( "icehmp_cat"     , h_ip       * zswi2   )       ! melt pond frac for categories
+         IF ( iom_use('iceafp_cat') )  CALL iom_put( "iceafp_cat"     , a_ip_frac  * zswi2   )       ! melt pond frac for categories
       ENDIF
       ! END MV MP 2016
